const Cc = Components.classes;
const Ci = Components.interfaces;

Components.utils.import("resource://gre/modules/Services.jsm");
Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

var ZeroWastePin = {
   addonGUID:'{677a8f98-fd64-40b0-a883-b8c95d0cbf18}',
   prefInstance:Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),     
   THUNDERBIRD_ID: "{3550f703-e582-4d05-9a08-453d09bdfdc6}",
   FIREFOX_ID: "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}",
   SEAMONKEY_ID:"{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}",   
   appInfo: Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo), 
   addonLiteralName:"Share Button for ZeroWaste",
   STRINGS:[], 
   enableZeroWastePin:function(event){
      ZeroWastePin.openZerowaste(event);  
   },
   getPrefValue:function(pref){
      var type=ZeroWastePin.prefInstance.getPrefType(pref);
      if(type==32) return ZeroWastePin.prefInstance.getCharPref(pref);
      else if(type==128) return ZeroWastePin.prefInstance.getBoolPref(pref);
      else if(type==64) return ZeroWastePin.prefInstance.getIntPref(pref);
   },
   setPrefValue:function(pref,value){
      var type=ZeroWastePin.prefInstance.getPrefType(pref);
      if(type==32) ZeroWastePin.prefInstance.setCharPref(pref,value);
      else if(type==128) ZeroWastePin.prefInstance.setBoolPref(pref,value);
      else if(type==64) ZeroWastePin.prefInstance.setIntPref(pref,value);
   },
   createAlertPrompt:function(promptString){
      var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
      prompt.alert(null, ZeroWastePin.addonLiteralName,promptString);      
   },
   createPromptPrompt:function(promptString){
      var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
      var input = {value:""}; 
      var check = {value:false};
      var result= prompt.prompt(null,ZeroWastePin.addonLiteralName,promptString,input,null,check);
      if(result==false) return null;
      else return input.value;
   },
   createConfirmPrompt:function(promptString){
      var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);         
      return prompt.confirm(null, ZeroWastePin.addonLiteralName,promptString);
   },
   mainWindowLoadHandler:function(window){   
      ZeroWastePin.UIBuilder.setupUI(window);
      window.setTimeout(function(){ZeroWastePin.instalandupdatecheck(window);},2000);
   },
   mainWindowUnloadHandler:function(window){
      ZeroWastePin.UIBuilder.tearDownUI(window);
      window.getBrowser().removeEventListener("DOMContentLoaded",ZeroWastePin.aboutblanklistener,true);
   }, 
   UIBuilder:{
      widgetCreated:false,
      setupUI:function(window){
         try{ZeroWastePin.UIBuilder.addToolbarButton(window);}catch(e){ZeroWastePinBootstrapAddon.lg(e,1);}
         try{ZeroWastePin.UIBuilder.addContextMenuItems(window);}catch(e){ZeroWastePinBootstrapAddon.lg(e,1);}       
         try{ZeroWastePin.UIBuilder.addToolsMenu(window);}catch(e){ZeroWastePinBootstrapAddon.lg(e,1);}
         try{ZeroWastePin.UIBuilder.addKeySet(window);}catch(e){ZeroWastePinBootstrapAddon.lg(e,1);}        
      },
      tearDownUI:function(window){
         try{ZeroWastePin.UIBuilder.removeToolbarButton(window);}catch(e){ZeroWastePinBootstrapAddon.lg(e,1);}
         try{ZeroWastePin.UIBuilder.removeContextMenuItems(window);}catch(e){ZeroWastePinBootstrapAddon.lg(e,1);}
         try{ZeroWastePin.UIBuilder.removeToolsMenu(window);}catch(e){ZeroWastePinBootstrapAddon.lg(e,1);}
         try{ZeroWastePin.UIBuilder.removeKeySet(window);}catch(e){ZeroWastePinBootstrapAddon.lg(e,1);}
      },
      createToolbarButton:function(document){
         var toolbarbutton = document.createElement("toolbarbutton");
         toolbarbutton.setAttribute("id", "zerowastepin-toolbarbutton");
         toolbarbutton.setAttribute("label", "Share Button for ZeroWaste");
         toolbarbutton.setAttribute("tooltiptext", "Share Button for ZeroWaste :: Click to Open Images Panel");
         toolbarbutton.setAttribute("class", (ZeroWastePin.appInfo.ID!=ZeroWastePin.SEAMONKEY_ID) ? "toolbarbutton-1" : "toolbarbutton-1 seamonkey");
         toolbarbutton.setAttribute("type", "button");
         toolbarbutton.addEventListener("command",function(event){ZeroWastePin.openPanel(event)},true);        
         return toolbarbutton;      
      },
      addToolbarButton:function(window){
         var document=window.document;
         if (window.CustomizableUI) {
            if(!ZeroWastePin.UIBuilder.widgetCreated){
               window.CustomizableUI.createWidget({
                  type: 'custom',
                  defaultArea: window.CustomizableUI.AREA_NAVBAR,
                  id:"zerowastepin-toolbarbutton",
                  onBuild:function(aDocument){
                     return ZeroWastePin.UIBuilder.createToolbarButton(aDocument);
                  }
               });
            }
            ZeroWastePin.UIBuilder.widgetCreated=true;
            if(!ZeroWastePin.getPrefValue("extensions.zerowastepin.tbplaced")) ZeroWastePin.UIBuilder.placeToolbarButton(window);
         }
         else{
            var toolbarbutton=ZeroWastePin.UIBuilder.createToolbarButton(document);
            (document.getElementById("navigator-toolbox") || document.getElementById("mail-toolbox")).palette.appendChild(toolbarbutton);
            ZeroWastePin.UIBuilder.placeToolbarButton(window,toolbarbutton);           
         }
         window.addEventListener("aftercustomization", ZeroWastePin.UIBuilder.afterCustomization, false);            
      },
      removeToolbarButton:function(window){
         if (window.CustomizableUI) {
            window.CustomizableUI.destroyWidget("zerowastepin-toolbarbutton");
         }
         else{
            var document = window.document;
            var buttonId="zerowastepin-toolbarbutton";
            var button=document.getElementById(buttonId);
            button.parentNode.removeChild(button);
         }
         window.removeEventListener("aftercustomization", ZeroWastePin.UIBuilder.afterCustomization, false);
      },
      placeToolbarButton:function(window,toolbarbutton){
         if(!ZeroWastePin.getPrefValue("extensions.zerowastepin.tbinsert")) return;
         var document=window.document;
         if (window.CustomizableUI) {
            window.CustomizableUI.addWidgetToArea("zerowastepin-toolbarbutton", window.CustomizableUI.AREA_NAVBAR,5);
            ZeroWastePin.setPrefValue("extensions.zerowastepin.tbplaced",true);
         }
         else{
            var toolbar = document.querySelector("[currentset^='" + toolbarbutton.id + ",'],[currentset*='," + toolbarbutton.id +
            ",'],[currentset$='," + toolbarbutton.id + "']");
            if(toolbar){
               var currentset=toolbar.getAttribute("currentset").split(",");
               var i=currentset.indexOf(toolbarbutton.id) + 1;
               var before=null;
               while (i < currentset.length && !(before=document.getElementById(currentset[i]))) i++;
               toolbar.insertItem(toolbarbutton.id, before, null, false);  
            }
            else{    
               var navbar = (document.getElementById("nav-bar") || document.getElementById("mail-bar3"));
               navbar.insertItem(toolbarbutton.id, null, null, false);        
            }
            if(!document.getElementById(toolbarbutton.id)) (toolbar || navbar).insertItem(toolbarbutton.id, null, null, false);           
         }
      },
      afterCustomization:function(event){
         var window=event.currentTarget;
         var document=window.document;
         var ythdprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
         if(!document.getElementById("zerowastepin-toolbarbutton") || document.getElementById("zerowastepin-toolbarbutton").parentNode.id=="BrowserToolbarPalette") ythdprefsinstance.setBoolPref("extensions.zerowastepin.tbinsert",false);
         else ythdprefsinstance.setBoolPref("extensions.zerowastepin.tbinsert",true);
      },
      addContextMenuItems:function(window){
         var document=window.document;
         var contentAreaContextMenu = document.getElementById('contentAreaContextMenu');
         /*
         var ppbmi = document.createElement("menuitem");
         ppbmi.setAttribute("id", "zerowastepin-zerowastepin");
         ppbmi.addEventListener("command",function(event){
            var window=event.currentTarget.ownerDocument.defaultView;
            var document=window.document; 
            var gContextMenu=window.gContextMenu;
            ZeroWastePin.pinImage(gContextMenu.mediaURL,gContextMenu.target.ownerDocument,gContextMenu.target.getAttribute("alt"),gContextMenu,window);
         },true);
         ppbmi.setAttribute("insertafter", "context-saveimage");
         ppbmi.setAttribute("class", "menuitem-iconic");
         ppbmi.setAttribute("label", "Share documents for ZeroWaste");
         ppbmi.setAttribute("hidden", "true");
         contentAreaContextMenu.insertBefore(ppbmi, document.getElementById("context-viewimage").nextSibling);
         var ppbbmi = document.createElement("menuitem");
         ppbbmi.setAttribute("id", "zerowastepin-zerowastepinbackground");
         ppbbmi.addEventListener("command",function(event){
            var window=event.currentTarget.ownerDocument.defaultView;
            var document=window.document; 
            var gContextMenu=window.gContextMenu;        
            ZeroWastePin.pinImage(gContextMenu.bgImageURL,gContextMenu.target.ownerDocument,gContextMenu.target.getAttribute("alt"),gContextMenu,window);
         },true);
         ppbbmi.setAttribute("insertafter", "context-viewbgimage");
         ppbbmi.setAttribute("class", "menuitem-iconic");
         ppbbmi.setAttribute("label", "Share Background Image for Zerowaste");
         ppbbmi.setAttribute("hidden", "true");
         contentAreaContextMenu.insertBefore(ppbbmi, document.getElementById("context-viewbgimage").nextSibling);
         */
         var ppbcmmi = document.createElement("menuitem");
         ppbcmmi.setAttribute("id", "zerowastepin-maincontextmenuitem");
         ppbcmmi.addEventListener("command",function(event){
            ZeroWastePin.openPanel(event);
         },true);
         //ppbcmmi.setAttribute("insertafter", "context-viewbgimage");
         ppbcmmi.setAttribute("class", "menuitem-iconic");
         ppbcmmi.setAttribute("label", "Share Images for Zerowaste");
         //ppbcmmi.setAttribute("hidden", "true");
         //contentAreaContextMenu.insertBefore(ppbcmmi, document.getElementById("context-viewbgimage").nextSibling);
         contentAreaContextMenu.appendChild(ppbcmmi);
         contentAreaContextMenu.addEventListener("popupshowing", ZeroWastePin.menuHideShow, false);         
      },
      removeContextMenuItems:function(window){
         var document = window.document;
         //document.getElementById("zerowastepin-zerowastepin").parentNode.removeChild(document.getElementById("zerowastepin-zerowastepin"));
         //document.getElementById("zerowastepin-zerowastepinbackground").parentNode.removeChild(document.getElementById("zerowastepin-zerowastepinbackground"));
         document.getElementById("zerowastepin-maincontextmenuitem").parentNode.removeChild(document.getElementById("zerowastepin-maincontextmenuitem"));
         document.getElementById('contentAreaContextMenu').removeEventListener("popupshowing", ZeroWastePin.menuHideShow, false);
      },
      addToolsMenu:function(window){
         var document=window.document;
         var toolsmenumi = document.createElement("menuitem");
         toolsmenumi.setAttribute("id", "zerowastepin-tools-menuitem");
         toolsmenumi.setAttribute("label", "Share Images for Zerowaste");
         toolsmenumi.setAttribute("class", "menuitem-iconic");
         toolsmenumi.setAttribute("accesskey", "p");
         toolsmenumi.addEventListener("command",function(event){ZeroWastePin.openPanel(event)},true);
         (document.getElementById("menu_ToolsPopup") || document.getElementById("taskPopup")).appendChild(toolsmenumi);    
      },
      removeToolsMenu:function(window){
         var document=window.document;
         document.getElementById("zerowastepin-tools-menuitem").parentNode.removeChild(document.getElementById("zerowastepin-tools-menuitem"));
      },
      addKeySet:function(window){
         var document=window.document;
         var zerowastepinbuttonkeyset = document.createElement("keyset");
         zerowastepinbuttonkeyset.setAttribute("id", "zerowastepinbutton-keyset");
         var zerowastepinbuttonactionkey = document.createElement("key");
         zerowastepinbuttonactionkey.setAttribute("id", "zerowastepinbutton-action-key");
         zerowastepinbuttonactionkey.setAttribute("modifiers", "accel alt");
         zerowastepinbuttonactionkey.setAttribute("key", "p");
         //Note for Validator: This is safe and it is a workaround. Otherwise "key" elements addded by bootstrap add-ons do not get triggered.
         zerowastepinbuttonactionkey.setAttribute("oncommand", "void(0);");
         zerowastepinbuttonactionkey.addEventListener("command", function(event){ZeroWastePin.openPanel(event);},false);
         zerowastepinbuttonkeyset.appendChild(zerowastepinbuttonactionkey);
         document.getElementById("main-window").appendChild(zerowastepinbuttonkeyset);
      },
      removeKeySet:function(window){
         var document=window.document;
         document.getElementById("zerowastepinbutton-keyset").parentNode.removeChild(document.getElementById("zerowastepinbutton-keyset"));
      },    
   }, 
   instalandupdatecheck:function(window){
      var mostRecentWindow=Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
      if(window!=mostRecentWindow) return;
      var getBrowser=window.getBrowser;
      if(ZeroWastePin.getPrefValue("extensions.zerowastepin.reinstall")){
         //getBrowser().addEventListener('DOMContentLoaded', ZeroWastePin.addonReinstall, true);
         ZeroWastePin.addonReinstall(window);
         return;
      }
      Components.utils.import("resource://gre/modules/AddonManager.jsm");  
      AddonManager.getAddonByID(ZeroWastePin.addonGUID, function(addon) {  
         var zerowastepinprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
         var zerowastepinversion = zerowastepinprefsinstance.getCharPref("extensions.zerowastepin.currentversion");
         var zerowastepinnewversion = addon.version;
         if (zerowastepinversion != zerowastepinnewversion) {
            //getBrowser().addEventListener('DOMContentLoaded', ZeroWastePin.zerowastepinFirstRun, true);
            ZeroWastePin.zerowastepinFirstRun(window);
         }
      });         
   },
   addonReinstall:function(window){
      //var window=event.currentTarget.ownerDocument.defaultView;
      var document=window.document;
      var getBrowser=window.getBrowser;
      //getBrowser().removeEventListener('DOMContentLoaded', ZeroWastePin.addonReinstall, true);
      var zerowastepinUrl;
      zerowastepinUrl=ZeroWastePin.firstRunURL;
      //getBrowser().selectedTab = getBrowser().addTab(zerowastepinUrl);
      ZeroWastePin.openURLInTab(window,zerowastepinUrl);
      ZeroWastePin.setPrefValue("extensions.zerowastepin.reinstall",false);         
   },
   zerowastepinFirstRun:function(window){
      //var window=event.currentTarget.ownerDocument.defaultView;
      var document=window.document;
      var getBrowser=window.getBrowser;   
      //getBrowser().removeEventListener('DOMContentLoaded', ZeroWastePin.zerowastepinFirstRun, true);
      var zerowastepininstalled = ZeroWastePin.getPrefValue("extensions.zerowastepin.currentversion") != "0";
      var zerowastepinUrl;
      if (!zerowastepininstalled) {
         zerowastepinUrl=ZeroWastePin.firstRunURL;
         //getBrowser().selectedTab = getBrowser().addTab(zerowastepinUrl);
         ZeroWastePin.openURLInTab(window,zerowastepinUrl);
      }
      else {
         zerowastepinUrl=ZeroWastePin.updateURL;
         //getBrowser().selectedTab = getBrowser().addTab(zerowastepinUrl);
         ZeroWastePin.openURLInTab(window,zerowastepinUrl);    
      }
      Components.utils.import("resource://gre/modules/AddonManager.jsm");  
      AddonManager.getAddonByID(ZeroWastePin.addonGUID, function(addon) {  
         var zerowastepinprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
         var zerowastepinversion = zerowastepinprefsinstance.getCharPref("extensions.zerowastepin.currentversion");
         var zerowastepinnewversion = addon.version;
         if (zerowastepinversion != zerowastepinnewversion) {
            zerowastepinprefsinstance.setCharPref("extensions.zerowastepin.currentversion", zerowastepinnewversion);
         }
      });
   },
   openURLInTab:function(window,url,prinstallrequested) {
      switch (ZeroWastePin.appInfo.ID) {
         case ZeroWastePin.THUNDERBIRD_ID:
            // Thunderbird's "openTab" implementation for the "contentTab" mode
            // automatically switches to an existing tab containing the URL we are
            // opening, so we don't have to check for one here.
            Components.classes['@mozilla.org/appshell/window-mediator;1'].
            getService(Components.interfaces.nsIWindowMediator).
            getMostRecentWindow("mail:3pane").
            document.getElementById("tabmail").
            openTab("contentTab", {contentPage: url, clickHandler: ("specialTabs.siteClickHandler(event,ZeroWastePin.reg());")});   
            break;
         case ZeroWastePin.FIREFOX_ID:
         default: {
            //window.openUILinkIn(url, "tab");
            var getBrowser=window.getBrowser;
            getBrowser().selectedTab = getBrowser().addTab(url,{relatedToCurrent: true});
            //window.focus();
         }
      }
   },
   handleStatusClick: function(event) {
      if (event.target.id == "zerowastepin-statusbar") {
         if (event.button == 0 || event.button == 1 || event.button == 2) {
            document.getElementById(document.getElementById('zerowastepin-statusbar').getAttribute("popupid")).openPopup(event.target,"before_start", -1, -1);
         } 
      }
   },
   addAddonListener:function(){
      var beingUninstalled;  
      let listener = {  
        onInstalling: function(addon) {  
         if (addon.id == ZeroWastePin.addonGUID) {  
           beingUninstalled = true;  
           if(ZeroWastePin.getPrefValue("extensions.zerowastepin.currentversion")==addon.version)              ZeroWastePin.setPrefValue("extensions.zerowastepin.reinstall",true);
         }  
        },  
        onUninstalling: function(addon) {  
         if (addon.id == ZeroWastePin.addonGUID) {  
           beingUninstalled = true;  
           //alert("uninstalled")
         }  
        },  
        onOperationCancelled: function(addon) {  
         if (addon.id == ZeroWastePin.addonGUID) {  
           beingUninstalled = (addon.pendingOperations & AddonManager.PENDING_UNINSTALL) != 0;  
           // alert("canceled")
         }  
        }  
      }  
      try {  
        Components.utils.import("resource://gre/modules/AddonManager.jsm");  
        AddonManager.addAddonListener(listener);  
      } catch(ex){} 
   },
   menuHideShow:function(event){
      var window=event.currentTarget.ownerDocument.defaultView;
      var document=window.document; 
      var gContextMenu=window.gContextMenu;  
      document.getElementById("zerowastepin-zerowastepin").hidden = !gContextMenu.onLoadedImage;
      
          var shouldShow = !(gContextMenu.isContentSelected ||
               gContextMenu.onImage || gContextMenu.onCanvas ||
               gContextMenu.onVideo || gContextMenu.onAudio ||
               gContextMenu.onLink || gContextMenu.onTextInput);
      
      document.getElementById("zerowastepin-zerowastepinbackground").hidden = !(shouldShow && !gContextMenu._hasMultipleBGImages);
      
      document.getElementById("zerowastepin-zerowastepinbackground").disabled = !gContextMenu.hasBGImage;
               
      document.getElementById("zerowastepin-zerowastepin").disabled = ZeroWastePin.disableSetDesktopBackground(gContextMenu);
   },
   requestAppendToolbar:function(){
   
      var zerowastepinprefsinstance = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
      var zerowastepintbadded = zerowastepinprefsinstance.getBoolPref("extensions.zerowastepin.tbadded");
      if(!zerowastepintbadded) {
         ZeroWastePin.appendToToolbar(); 
         zerowastepinprefsinstance.setBoolPref("extensions.zerowastepin.tbadded",true);
      }
   
   },    
   appendToToolbar: function() {
      if (!window.CustomizableUI) { 
         // Get the current navigation bar button set (a string of button IDs) and append
         // ID of the Firebug start button into it.
         var startButtonId =  "zerowastepin-toolbarbutton";
         var navBarId = "nav-bar";
         var navBar = document.getElementById(navBarId);
         var currentSet = navBar.currentSet;
   
         // Append only if the button is not already there.
         var curSet = currentSet.split(",");
         if (curSet.indexOf(startButtonId) == -1)
         {
            navBar.insertItem(startButtonId);
            navBar.setAttribute("currentset", navBar.currentSet);
            document.persist("nav-bar", "currentset");
   
            try
            {
               // The current global scope is not browser.xul.
               top.BrowserToolboxCustomizeDone(true);
            }
            catch (e)
            {
      
            }
            
         }
   
         // Don't forget to show the navigation bar - just in case it's hidden.
         // Dom.collapse(navBar, false);
         //document.persist(navBarId, "collapsed");
      }
      else {
         var ids=["zerowastepin-toolbarbutton"];
         var add=1;
         for (let id of ids) {
            if(add){
               if(!window.CustomizableUI.getPlacementOfWidget(id)){
                  window.CustomizableUI.addWidgetToArea(id, CustomizableUI.AREA_NAVBAR);
               }
            }
            else{
               window.CustomizableUI.removeWidgetFromArea(id);                      
            }
         }
      }        
   },
   disableSetDesktopBackground: function(gContextMenu) {
      // Disable the Set as Desktop Background menu item if we're still trying
      // to load the image or the load failed.
      if (!(gContextMenu.target instanceof Components.interfaces.nsIImageLoadingContent))
        return true;

      if (("complete" in gContextMenu.target) && !gContextMenu.target.complete)
        return true;

      if(gContextMenu.target.currentURI) {if (gContextMenu.target.currentURI.schemeIs("javascript")) return true;}

      var request = gContextMenu.target
                    .QueryInterface(Components.interfaces.nsIImageLoadingContent)
                    .getRequest(Components.interfaces.nsIImageLoadingContent.CURRENT_REQUEST);
      if (!request)
        return true;

      return false;
   },
   openPanel:function(event){
      var document=event.currentTarget.ownerDocument;
      var window=document.defaultView;
      var doc=window.content.document;
      if(doc.getElementById("ppb_panel")){
         doc.body.classList.remove("ppb_overflow_hidden");
         doc.getElementById("ppb_panel").parentNode.removeChild(doc.getElementById("ppb_panel"));
         return;
      }
      var paddingLeft=(doc.body.clientWidth%261)/2;
      doc.body.classList.add("ppb_overflow_hidden");
      var div=doc.createElement("div");
      div.setAttribute("id","ppb_panel");
      div.style.setProperty("padding-left",paddingLeft+"px", "important");
      div.addEventListener("click",function(event){
         if(event.target==event.currentTarget) {
            this.ownerDocument.body.classList.remove("ppb_overflow_hidden");
            this.parentNode.removeChild(this);
         }
      },false);

      // Create Panel form
   
      var doctypes = {  "Article" : "Article",
                        "Article de presse" : "Article+de+presse",
                        "Audio" : "Audio",
                        "C\u00e9d\u00e9rom" : "C%e9d%e9rom",
                        "Comuniqu\u00e9 de presse" : "Communiqu%e9+de+presse",
                        "Dictionnaire" : "Dictionnaire",
                        "Entretien" : "Entretien",
                        "Etude / Rapport" : "Etude / rapport",
                        "Guide" : "Guide",
                        "Image" : "Image",
                        "Infographie" : "Infographie",
                        "M\u00e9moire et th\u00e8se" : "M%e9moire+et+th%e8se",
                        "Outils p\u00e9dagogiques" : "Outils+p%e9dagogiques",
                        "Ouvrage" : "Ouvrage",
                        "R\u00e8glementation" : "R%e8glementation",
                        "Revue" : "Revue",
                        "Site Internet" : "Site+internet",
                        "Synth\u00e8se" : "Synth%e8se",
                        "Texte officiel" : "Texte+officiel",
                        "Vid\u00e9o" : "Vid%e9o",
                        "WebPage" : "WebPage",
                        "Zero Waste France" : "Zero+Waste+France"
                     };

      var headBox = doc.createElement("div");
         headBox.id = "headBox";
         headBox.innerHTML = "<h2>Base documentaire ZeroWaste France</h2>";
         // document type list
         var selectList = doc.createElement("select");
         selectList.id = "selectList";
         for(var dtype in doctypes){
            dtype = dtype; //works with unicode
            //dtype = decodeURIComponent(unescape(dtype)); // idem 
            var option = doc.createElement('option');
            option.value = doctypes[dtype];
            option.text = unescape(dtype);
            selectList.appendChild(option);
         }
         headBox.innerHTML += "<br> Type: ";
         headBox.appendChild(selectList);

         // image URL
         var imageURL = doc.createElement("INPUT");
         imageURL.type = "text";
         imageURL.id = "imageURL";
         headBox.innerHTML += "<br> Image URL: ";
         headBox.appendChild(imageURL);

         // sumbit   
         var submit = doc.createElement("input");
         submit.type = "submit";
         submit.value = "Envoyer";
         headBox.innerHTML += "<br>";
         headBox.appendChild(submit);

      div.appendChild(headBox);

      // images
      var imgBox = doc.createElement("div");
      imgBox.id="imgBox";
      div.appendChild(imgBox);
      var images=doc.getElementsByTagName("img");
      if(images.length==0){
         var p=doc.createElement("p");
         p.appendChild(document.createTextNode("No images found. You may want to right click on the image and choose ZeroWaste menu optionally!"));
         div.appendChild(p);
      }
      else {
         var noDuplicates=[];
         var imageSrcArray=[];
         for(var i=0; i< images.length; i++) {
            if(images[i].naturalWidth > 50 && images[i].naturalHeight >50 ){
               if(imageSrcArray.length==0) imageSrcArray.push(images[i].src);
               else if(imageSrcArray.indexOf(images[i].src)==-1) {
                  imageSrcArray.push(images[i].src);
                  noDuplicates.push(images[i]);
               }
            }
         }
         var imageArray=noDuplicates;
         var imagedimensions = [];
         for(var i=0; i< imageArray.length; i++) {
            imagedimensions.push([imageArray[i].naturalWidth, imageArray[i].naturalHeight, imageArray[i]]);
         }
         imagedimensions.sort(function (a, b) {
               if (b[0] - a[0] === 0) return b[1] - a[1];
               return b[0] - a[0];
               });
         for(var i=0;i<imagedimensions.length;i++){
            var img=imagedimensions[i][2].cloneNode(true);
            var thumbdiv=doc.createElement("div");
            thumbdiv.setAttribute("class","ppb_thumb_image");
            thumbdiv.setAttribute("imgsrc",imagedimensions[i][2].src);
            thumbdiv.setAttribute("imgalt",imagedimensions[i][2].alt);
            thumbdiv.setAttribute("imgdims",imagedimensions[i][2].naturalWidth+"x"+imagedimensions[i][2].naturalHeight);
            thumbdiv.setAttribute("style","background-image:url('"+img.src+"') !important;background-repeat:no-repeat !important;background-position:center !important;");
            thumbdiv.addEventListener("click",function(event){
                  var imgSrc=event.currentTarget.getAttribute("imgsrc");
                  doc.getElementById("imageURL").value = imgSrc;
                  },false);
            imgBox.appendChild(thumbdiv);
         }
      }

      // get page infos
      var page_description ="";
      var page_title = "";
      var page_authors = "";
      var page_date = "";

      // Meta
      var metas = doc.getElementsByTagName('meta');
      for (var x=0,y=metas.length; x<y; x++) {
         if (metas[x].name.toLowerCase() == "description" 
               || metas[x].getAttribute("property") == "og:description" ) {
            page_description = metas[x].content;
         }
         if (metas[x].name.toLowerCase() == "title" || metas[x].getAttribute("property") == "og:title" ) {
            page_title = metas[x].content;
         }
         if (metas[x].name.toLowerCase() == "author" || metas[x].getAttribute("property") == "og:author" ) {
            page_authors = metas[x].content;
         }
      }

      // Span
      var spans = doc.querySelectorAll('span,a,time,strong');
      for (var x=0,y=spans.length; x<y; x++) {
         var prop = spans[x].getAttribute('itemprop');
         if (prop == "author" && page_authors == "")
            page_authors = spans[x].innerHTML.replace(/<(?:.|\n)*?>/gm, '');
            page_authors = page_authors.replace(/\s\s+/g, ' '); //remove tag and spaces
         if (prop == "datePublished" && page_date == ""){
            thedate = new Date(spans[x].getAttribute('datetime'));
            if (!isNaN(thedate))
               page_date = thedate.getDate() + "/" + (thedate.getMonth()+1) + "/" +thedate.getFullYear();
         }
      }

      // Others
      if (page_title == ""){
         if(doc.title != "") page_title = doc.title
      }


      // ----------------- Clean page infos

      page_title = cleanData(page_title);
      page_description = cleanData(page_description);
      page_authors = cleanData(page_authors);

      // removing Unicode 
      page_title = escape(page_title).replace(/%u2019/g, "%27").replace(/%u2013/g,"-");
      page_date = escape(page_date).replace(/%u2019/g, "%27").replace(/%u2013/g,"-");
      page_description = escape(page_description).replace(/%u2019/g, "%27").replace(/%u2013/g,"-");
      page_authors = escape(page_authors).replace(/%u2019/g, "%27").replace(/%u2013/g,"-");
      page_URL = escape(doc.location.href).replace(/%u2019/g, "%27").replace(/%u2013/g,"-");

      submit.addEventListener("click",function(event){
         // Build URL
            var type=doc.getElementById("selectList").value;
            var url='http://zerowastefrance.kentikaas.com/'+
               'EditRecord.htm?table=3&site=&filtre=0&act=add'+
               '&type='+type+
               '&field_21='+page_title+
               '&field_41='+page_date+
               '&field_131='+page_description+
               '&field_151='+page_authors+
               '&field_1081='+page_URL+
               '&field_1091='+doc.getElementById("imageURL").value
            ;
            if(typeof window.gMultiProcessBrowser !== "undefined" && window.gMultiProcessBrowser) {
               window.gBrowser.selectedTab = window.gBrowser.addTab(
                  url,'PinWindow','height='+2000+
                  ',width='+1000+', resizable=0,scrollbars=1,menubar=0,toolbar=0,location=1,status=0,statusbar=0'+
                  ',top='+50+',left='+50);
            }
            else{
               window.open(url,'PinWindow','height='+800+',width='+800+
                  ', resizable=1,scrollbars=1,menubar=0,toolbar=0 ,location=1,status=0,statusbar=0'+
                  ',top='+50+',left='+50);
            }
      },false);

      doc.documentElement.appendChild(div);
   }
}

function cleanData(data){
   try {
      data = decodeURIComponent(data);
      data = unescape(data);
   }
   catch (e) {
      data = unescape(data);
   }
   
   return data;
}

function ZeroWastePinStartup() { 
}
ZeroWastePinStartup.prototype = {
   classID:Components.ID("{927c4a48-6636-4765-af3f-bb73b9065af6}"),
   contractID:"@zerowastepin/bootstartup;1",
   classDescription:"ZeroWastePin BootStartup",
   QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsIObserver, Components.interfaces.nsISupportsWeakReference, Components.interfaces.nsISupports]),
   get wrappedJSObject(){return(this);},
   observe: function(aSubject,aTopic,aData){
      switch(aTopic) {
        case "http-on-modify-request":
         break;       
        case "quit-application":
         break;
        case "quit-application-requested":   
         break;      
        default:
         throw Components.Exception("Unknown topic: "+aTopic);
      }
   },
   registerObservers:function(){
   },
   unregisterObservers:function(){
   },
   prefObserver:{
      register: function(){
         var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Components.interfaces.nsIPrefService);
         this._branch = prefService.getBranch("extensions.zerowastepin.");
         this._branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
         this._branch.addObserver("", this, false);
      },
      unregister: function(){
         if(!this._branch) {return;}
         this._branch.removeObserver("", this);
      },
      observe: function(aSubject, aTopic, aData){
         if(aTopic != "nsPref:changed") {return;}
         if(aData=="enableembeddedvideo"){
            var ythdprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
            var ythdenableembeddedvideo = ythdprefsinstance.getBoolPref("extensions.zerowastepin.enableembeddedvideo");
            if(ythdenableembeddedvideo) Components.classes["@zerowastepin/bootstartup;1"].getService().wrappedJSObject.registerObservers();
            else Components.classes["@zerowastepin/bootstartup;1"].getService().wrappedJSObject.unregisterObservers();
         }
      }
   }, 
   registerPrefObserver:function(){
      this.prefObserver.register(); 
   }, 
   unregisterPrefObserver:function(){
      this.prefObserver.unregister(); 
   },
   requestAddFullPageCSS:function(){
      ZeroWastePinBootstrapAddon.addFullPageCSS();
   },
   requestRemoveFullPageCSS:function(){
      ZeroWastePinBootstrapAddon.removeFullPageCSS();
   }
}

var WindowListener = {
   setupBrowserUI: function(window,closebar) {
      // Take any steps to add UI or anything to the browser window
      // document.getElementById() etc. will work here 
      try{
         ZeroWastePin.mainWindowLoadHandler(window);
      } catch(e){
         ZeroWastePinBootstrapAddon.lg(e,1);
      }     
   },
   tearDownBrowserUI: function(window) {
      // Take any steps to remove UI or anything from the browser window
      // document.getElementById() etc. will work here
      ZeroWastePin.mainWindowUnloadHandler(window);
   },
   // nsIWindowMediatorListener functions
   onOpenWindow: function(xulWindow) {
      // A new window has opened
      var domWindow = xulWindow.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                         .getInterface(Components.interfaces.nsIDOMWindow);
      // Wait for it to finish loading
      domWindow.addEventListener("load", function listener() {
         domWindow.removeEventListener("load", listener, false);
         // If this is a browser window then setup its UI     
         if (domWindow.document.documentElement.getAttribute("windowtype") == "navigator:browser") WindowListener.setupBrowserUI(domWindow);
      }, false);
   },
   onCloseWindow: function(xulWindow) {
   },
   onWindowTitleChange: function(xulWindow, newTitle) {
   }
};

var ZeroWastePinBootstrapAddon = {
   prefsinstance:Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),
   startup:function(data,reason){
      this.requestAddPrerequisites(data);
      //this.registerComponent();
      this.setDefaultPrefs();
      this.addAddonListener();
      this.setDefaultLocalizations();
      this.setupBrowserUI();
      this.addWindowListener();
      this.addAddonSkinCSS();
      //this.requestAddFullPageCSS();
      //this.requestRegisterObservers();
      //this.requestRegisterPrefObserver();  
   },
   shutdown:function(data,reason){
      // When the application is shutting down we normally don't have to clean
      // up any UI changes made
      if (reason == APP_SHUTDOWN) return;
      this.removeAddonListener();
      this.removeDefaultLocalizations();
      this.tearBrowserUI();
      this.removeWindowListener();
      this.removeAddonSkinCSS();
      //this.removeFullPageCSS();      
      //this.requestUnregisterObservers();
      //this.requestUnregisterPrefObserver();
      //this.unregisterComponent();
      this.requestRemovePrerequisites(data);
   }, 
   requestAddPrerequisites:function(data){
       this.addResourceProtocol(data); 
       this.addChromeProtocol(data);   
   },
   requestRemovePrerequisites:function(data){
       this.removeResourceProtocol(data); 
       this.removeChromeProtocol(data);   
   },
   addResourceProtocol:function(data){
      var ios=Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
      var rh=ios.getProtocolHandler("resource").QueryInterface(Components.interfaces.nsIResProtocolHandler);
      var nfu=ios.newFileURI(data.installPath);
      var isDir=data.installPath.isDirectory();
      if (isDir) {nfu=ios.newURI(nfu.spec+"/",null,null);} 
      else {nfu=ios.newURI("jar:"+nfu.spec+"!/",null,null);}
      //Note for Validator: This is safe and used to register resource protocol for our add-on, i.e. resource://zerowastepin/
      rh.setSubstitution("zerowastepin",nfu);
   },
   removeResourceProtocol:function(data) {
      var ios=Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
      var r=ios.getProtocolHandler("resource").QueryInterface(Components.interfaces.nsIResProtocolHandler);
      r.setSubstitution("zerowastepin",null);
   }, 
   addChromeProtocol:function(data){
      if (Services.vc.compare(Services.appinfo.platformVersion, "10.0") < 0 && Services.vc.compare(Services.appinfo.platformVersion, "8.0") >= 0)  
         Components.manager.addBootstrappedManifestLocation(data.installPath);   
   },
   removeChromeProtocol:function(data) {
      if (Services.vc.compare(Services.appinfo.platformVersion, "10.0") < 0 && Services.vc.compare(Services.appinfo.platformVersion, "8.0") >= 0)  
         Components.manager.removeBootstrappedManifestLocation(data.installPath);
   },
   registerComponent:function(){
      if (XPCOMUtils.generateNSGetFactory)
         var NSGetFactory = XPCOMUtils.generateNSGetFactory([ZeroWastePinStartup]);
      var componentRegistrar = Components.manager.QueryInterface(Components.interfaces.nsIComponentRegistrar)
      var contractID = ZeroWastePinStartup.prototype.contractID;
      try{
         componentRegistrar.unregisterFactory(componentRegistrar.contractIDToCID(contractID), componentRegistrar.getClassObjectByContractID(contractID, Ci.nsISupports));
      }catch(e){}
      var component = ZeroWastePinStartup.prototype;
      var factory = NSGetFactory(component.classID)
      //Note for Validator: This is safe and used to register a generic component for our add-on.
      componentRegistrar.registerFactory(component.classID, component.classDescription, component.contractID, factory);
   },
   unregisterComponent:function(reason){
      var componentRegistrar = Components.manager.QueryInterface(Components.interfaces.nsIComponentRegistrar);
      componentRegistrar.unregisterFactory(componentRegistrar.contractIDToCID("@zerowastepin/bootstartup;1"),componentRegistrar.getClassObjectByContractID("@zerowastepin/bootstartup;1", Components.interfaces.nsISupports));
   }, 
   setDefaultPrefs:function(){
      function setDefaultPrefs(name, value){
         function setPrefs(branch, name ,value){
            if(typeof value == "string"){
               var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
               str.data = value;
               branch = branch ? branch : Services.prefs;
               branch.setComplexValue(name, Components.interfaces.nsISupportsString, str);
            }
            else if(typeof value == "number"){
               branch.setIntPref(name, value);
            }
            else if(typeof value == "boolean"){
               branch.setBoolPref(name, value);
            }
         }
         var defaultBranch = Services.prefs.getDefaultBranch(null);
         setPrefs(defaultBranch, name, value);
      }
      Services.scriptloader.loadSubScript(this.getPrefsJS(), {pref:setDefaultPrefs});  
   },
   getPrefsJS:function(){
      return "resource://zerowastepin/defaults/preferences/defaults.js";
   },
   addAddonListener:function(){
      try {  
         Components.utils.import("resource://gre/modules/AddonManager.jsm");  
         AddonManager.addAddonListener(this.AddonListener);  
      } catch (ex) {}   
   },
   removeAddonListener:function(){
      try {  
         Components.utils.import("resource://gre/modules/AddonManager.jsm");  
         AddonManager.removeAddonListener(this.AddonListener);  
      } catch (ex) {} 
   }, 
   AddonListener:{  
      onInstalling: function(addon) {  
         if (addon.id == "{677a8f98-fd64-40b0-a883-b8c95d0cbf17}") {  
            var version=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getCharPref("extensions.zerowastepin.currentversion");
            if(version==addon.version) Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).setBoolPref("extensions.zerowastepin.reinstall",true);
         }  
      },  
      onUninstalling: function(addon) {  
         if (addon.id == "{677a8f98-fd64-40b0-a883-b8c95d0cbf17}") {
            //foo
         }  
      },  
      onOperationCancelled: function(addon) {  
         if (addon.id == "{677a8f98-fd64-40b0-a883-b8c95d0cbf17}") {
            //foo
         }  
      }  
   },
   setDefaultLocalizations:function(){
      Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).flushBundles();
      ZeroWastePin.STRINGS["zerowastepin.properties"]=Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://zerowastepin/locale/zerowastepin.properties");
      ZeroWastePin.STRINGS["zerowastepin_bootstrap.properties"]=Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://zerowastepin/locale/zerowastepin_bootstrap.properties");
   },
   removeDefaultLocalizations:function(){
      ZeroWastePin.STRINGS=[];
      Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).flushBundles();
   },
    getLocaleString:function(filename, aKey, aLocale) {
      if(aLocale == null) {
         aLocale=Cc["@mozilla.org/chrome/chrome-registry;1"]
            .getService(Ci.nsIXULChromeRegistry).getSelectedLocale("global");
      }
      var addon = {
         getResourceURI: function(filePath) ({
            spec: __SCRIPT_URI_SPEC__ + "/../" + filePath
         })
      }
      function filepath(locale) addon.getResourceURI("chrome/locale/" + locale + "/" + filename).spec;
      function getStr(aStrBundle, aKey) {
         if (!aStrBundle) return false;
         try {
            return aStrBundle.GetStringFromName(aKey);
         } catch (e) {}
         return "";
      }
      let splitter = /(\w+)-\w+/;
      let locale = Cc["@mozilla.org/chrome/chrome-registry;1"].getService(Ci.nsIXULChromeRegistry).getSelectedLocale("global");
      let defaultBundle = Services.strings.createBundle(filepath(locale));
      let localeBundle, localeBasicBundle;
      let defaultLocale = "en";
      let defaultBasicBundle;
      let (locale_zerowastepin = locale.match(splitter)) {
         if (locale_zerowastepin) {
            defaultBasicBundle = Services.strings.createBundle(filepath(locale_zerowastepin[1]));
         }
      }    
      let addonsDefaultBundle = Services.strings.createBundle(filepath(defaultLocale));   
      if (aLocale) {
         localeBundle = Services.strings.createBundle(filepath(aLocale));
         let locale_zerowastepin = aLocale.match(splitter)
         if (locale_zerowastepin) localeBasicBundle = Services.strings.createBundle(filepath(locale_zerowastepin[1]));
      }
      return getStr(localeBundle, aKey)
         || getStr(localeBasicBundle, aKey)
         || getStr(defaultBundle, aKey)
         || getStr(defaultBasicBundle, aKey)
         || getStr(addonsDefaultBundle, aKey);
    },   
   setupBrowserUI:function(){
      let wm = Cc["@mozilla.org/appshell/window-mediator;1"].
            getService(Ci.nsIWindowMediator);
      // Get the list of browser windows already open
      let windows = wm.getEnumerator("navigator:browser");
      while (windows.hasMoreElements()) {
         let domWindow = windows.getNext().QueryInterface(Ci.nsIDOMWindow);
         WindowListener.setupBrowserUI(domWindow,false);
      }
   },
   tearBrowserUI:function(){
      let wm = Cc["@mozilla.org/appshell/window-mediator;1"].
            getService(Ci.nsIWindowMediator);
      // Get the list of browser windows already open
      let windows = wm.getEnumerator("navigator:browser");
      while (windows.hasMoreElements()) {
         let domWindow = windows.getNext().QueryInterface(Ci.nsIDOMWindow);
         WindowListener.tearDownBrowserUI(domWindow);
      }
   },
   addWindowListener:function(){
      let wm = Cc["@mozilla.org/appshell/window-mediator;1"].
            getService(Ci.nsIWindowMediator);
      // Wait for any new browser windows to open
      wm.addListener(WindowListener);
   },
   removeWindowListener:function(){
      let wm = Cc["@mozilla.org/appshell/window-mediator;1"].
            getService(Ci.nsIWindowMediator);
      // Stop listening for any new browser windows to open    
      wm.removeListener(WindowListener);  
   },
   registerStyle:function(url){
      var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"]
                     .getService(Components.interfaces.nsIStyleSheetService);
      var ios = Components.classes["@mozilla.org/network/io-service;1"]
                     .getService(Components.interfaces.nsIIOService);
      var uri = ios.newURI(url, null, null);
      if(!sss.sheetRegistered(uri, sss.USER_SHEET))
         //Note for Validator: This is safe and used to register our add-on skin, i.e. chrome://zerowastepin/skin/zerowastepin.css
         sss.loadAndRegisterSheet(uri, sss.USER_SHEET);  
   },
   unregisterStyle:function(url){
      var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"]
                     .getService(Components.interfaces.nsIStyleSheetService);
      var ios = Components.classes["@mozilla.org/network/io-service;1"]
                     .getService(Components.interfaces.nsIIOService);
      var u = ios.newURI(url, null, null);
      if(sss.sheetRegistered(u, sss.USER_SHEET))
        sss.unregisterSheet(u, sss.USER_SHEET);    
   }, 
   addAddonSkinCSS:function(){
      this.registerStyle(this.getOverlayCSS());
   },
   removeAddonSkinCSS:function(){
      this.unregisterStyle(this.getOverlayCSS());
   },
   getOverlayCSS:function(){
      return "chrome://zerowastepin/skin/zerowastepin.css";
   }, 
   requestAddFullPageCSS:function(){
      if(this.prefsinstance.getCharPref("extensions.zerowastepin.currentvideosize")=="fullpage") this.addFullPageCSS(); 
   },
   addFullPageCSS:function(){
      this.registerStyle(this.getFullPageCSS());         
   },
   removeFullPageCSS:function(){
      this.unregisterStyle(this.getFullPageCSS());      
   },
   getFullPageCSS:function(){
      return "chrome://zerowastepin/content/style.css";
   }, 
   requestRegisterObservers:function(){
      if(this.prefsinstance.getBoolPref("extensions.zerowastepin.enableembeddedvideo")) {
         var c=Components.classes["@zerowastepin/bootstartup;1"].getService().wrappedJSObject;
         c.registerObservers();
      }  
   },
   requestUnregisterObservers:function(){
      if(this.prefsinstance.getBoolPref("extensions.zerowastepin.enableembeddedvideo")) {
         var c=Components.classes["@zerowastepin/bootstartup;1"].getService().wrappedJSObject;
         c.unregisterObservers();
      }  
   },
   requestRegisterPrefObserver:function(){
      var c=Components.classes["@zerowastepin/bootstartup;1"].getService().wrappedJSObject;
      c.registerPrefObserver();
   },
   requestUnregisterPrefObserver:function(){
      var c=Components.classes["@zerowastepin/bootstartup;1"].getService().wrappedJSObject;
      c.unregisterPrefObserver();
   },
   lg:function(e,m){
      switch(m) {
         case 0:
            var console = (Components.utils.import("resource://gre/modules/devtools/Console.jsm", {})).console;
            console.log(e);         
         break;
         case 1:
            var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
            .getService(Components.interfaces.nsIPromptService);
            prompts.alert(null, "Share Button for ZeroWaste", e + ((e.lineNumber) ? ("\n" + e.lineNumber) : ""));       
         break;
         case 2:
            Components.utils.reportError(e + ((e.lineNumber) ? ("\n" + e.lineNumber) : ""));
         break;
         default:
         //throw Components.utils.reportError("Unknown topic: "+e);
      }
   }
}

function install(data) {
}

function uninstall(data,reason){
   if(reason!=ADDON_UNINSTALL) return;
   Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.zerowastepin.").deleteBranch("");
   Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).flushBundles();
}

function startup(data, reason) {
   try{
      ZeroWastePinBootstrapAddon.startup(data,reason);
   } catch(e){
      ZeroWastePinBootstrapAddon.lg(e,1);
   }
}

function shutdown(data, reason) {
   try{
      ZeroWastePinBootstrapAddon.shutdown(data,reason);
   } catch(e){
      ZeroWastePinBootstrapAddon.lg(e,1);
   }
}
